// crappy to use the similar to "hot_keys.cpp" name, but need to unite/exclude hotkeys subroutines

#include "hotkeys.h"
#include "error.h"
#include <sstream>
using namespace std;
#include "screen.h"
#include "main.h"
#include <process.h>
#include "volume.h"
#include "configuration.h"
#include "macros.h"
#include "wnd_console.h"
#include "notify.h"


// using this one and not giving 'hotkey_info_t' between functions, because some values needs to be static
hotkey_info_t hotkey_info;
CHotKeys* hot_keys = 0;
bool hotkey_exit = 0;

typedef struct
{
	uint val;
//	const uint val;
	const char* name;
//	const char* const name;
} strlist_t;
//#define STRENUM_ADD(_str_) (_str_)
#define STRLIST_ADD(_str_) {##_str_, #_str_}

#define STRLIST_ADD_VK(_str_) {VK_##_str_, #_str_}
// todo :  full list
strlist_t g_strlist[] =
{
	STRLIST_ADD_VK(LEFT),
	STRLIST_ADD_VK(UP),
	STRLIST_ADD_VK(RIGHT),
	STRLIST_ADD_VK(DOWN),

	STRLIST_ADD_VK(F1),
	STRLIST_ADD_VK(F2),
	STRLIST_ADD_VK(F3),
	STRLIST_ADD_VK(F4),
	STRLIST_ADD_VK(F5),
	STRLIST_ADD_VK(F6),
	STRLIST_ADD_VK(F7),
	STRLIST_ADD_VK(F8),
	STRLIST_ADD_VK(F9),
	STRLIST_ADD_VK(F10),
	STRLIST_ADD_VK(F11),
	STRLIST_ADD_VK(F12),
	STRLIST_ADD_VK(F13),
	STRLIST_ADD_VK(F14),
	STRLIST_ADD_VK(F15),
	STRLIST_ADD_VK(F16),
	STRLIST_ADD_VK(F17),
	STRLIST_ADD_VK(F18),
	STRLIST_ADD_VK(F19),
	STRLIST_ADD_VK(F20),
	STRLIST_ADD_VK(F21),
	STRLIST_ADD_VK(F22),
	STRLIST_ADD_VK(F23),
	STRLIST_ADD_VK(F24),
};


//void Hotkeys_Init (HWND hwnd)
void Hotkeys_Init ()
{
	memset (&hotkey_info, 0, sizeof(hotkey_info));
//	hot_keys = new CHotKeys (hwnd);
	hot_keys = new CHotKeys ();
	if (! hot_keys)
		Error ("Hotkeys_Init () :  new CHotKeys () failed");
}

void Hotkeys_Quit ()
{
// *also must free strdups of user_data actually;
// now there aren't strdups, but new instead, but the things seems become more harder :  how to delete 'user_data' now then ...
	delete hot_keys;
	hot_keys = 0;
}

#if 0
void Hotkey_Modifier_Clear ()
{
	hotkey_info.modifier = 	0;
}

void Hotkey_Modifier_Add (string mod)
{
	ulong modifier;

	;
	hotkey_info.modifier = 	modifier;
}
#endif

#if 0
//void Hotkey_SetModifier (string mod)
// *will modify given vector
void Hotkey_SetModifier (vec_str_t& vec_str_args)
{
//	stringstream strm;
	string val0;
	string* mod;

	hotkey_info.modifier = 	0;
//	strm << mod;
	while (1)
	{
//		mod = vec_str_args.pop_back();
		mod = &vec_str_args.back();
#if 0
// clear stream contains
		strm.str("");
		strm.clear();
		strm << mod;
#endif
//		vec_str_args.pop_back();
// necessary on MSVC 7.1, 8.0; otherwise a last value in 'val0' will remain, and will dead-loop
//		val0.erase();
//		strm >> val0;
//		if (val0.empty())
//			break;
		if (! cmpi(val0, "Shift"))
		{
			hotkey_info.modifier |= MOD_SHIFT;
			continue;
		}
		if (! cmpi(val0, "Control"))
		{
			hotkey_info.modifier |= MOD_CONTROL;
			continue;
		}
		if (! cmpi(val0, "Ctrl"))
		{
			hotkey_info.modifier |= MOD_CONTROL;
			continue;
		}
		if (! cmpi(val0, "Alt"))
		{
			hotkey_info.modifier |= MOD_ALT;
			continue;
		}
		if (! cmpi(val0, "Win"))
		{
			hotkey_info.modifier |= MOD_WIN;
			continue;
		}
		Error ("Hotkey config :  unknown value \"%s\" for hotkey_modifier", val0.c_str());
	}
}
#else
void Hotkey_SetModifier (vec_str_t& vec_str_args)
{
	vec_str_t::iterator it;
	vec_str_t::iterator it_end;
	string* mod;

	hotkey_info.modifier = 	0;
	it = vec_str_args.begin();
	it_end = vec_str_args.end();
	for (; it != it_end; it++)
	{
		mod = &*it;
		if (mod->empty())
			continue;
		if (! cmpi(*mod, "Shift"))
		{
			hotkey_info.modifier |= MOD_SHIFT;
			continue;
		}
		if (! cmpi(*mod, "Control"))
		{
			hotkey_info.modifier |= MOD_CONTROL;
			continue;
		}
		if (! cmpi(*mod, "Ctrl"))
		{
			hotkey_info.modifier |= MOD_CONTROL;
			continue;
		}
		if (! cmpi(*mod, "Alt"))
		{
			hotkey_info.modifier |= MOD_ALT;
			continue;
		}
		if (! cmpi(*mod, "Win"))
		{
			hotkey_info.modifier |= MOD_WIN;
			continue;
		}
		Error ("Hotkey config :  unknown value \"%s\" for hotkey_modifier", mod->c_str());
	}
}
#endif

// as input may be :  chars (in ' quotes), key names, numbers.
// for virtual key names you may look in the "winuser.h" file; their defines are starting with "VK_";
// codes, which you may use as numbers also are in those defines
bool Hotkey_ParseKey (string& str_key, int& virtual_key_code)
{
	int len;
	stringstream strm;
	int i;
	string str;

	len = str_key.length();
	if (! len)
	{
		Error ("Hotkey :  definition without key name");
		return 0;
	}
//	strm << str_key;

// +++ character +++
// allow to input low case characters; and upper case characters will be good for two parsing cases :  chars and key names
// 0 - 9, A - Z, space
// bad :/ ; when displaying an error, the information may appear not the same as in the origin
//	str_key.mkupper ();
	if (str_key[0] == '\'')
	{
		char c;

		if (len != 3)
		{
			Error ("Hotkey :  character \"%s\" parsing error; if you need a character, then it must be like 'A', with alphanum character; it is exactly three symbols", str_key.c_str());
			return 0;
		}
		if (str_key[2] != '\'')
		{
			Error ("Hotkey :  character \"%s\" does not finishes with ' symbol", str_key.c_str());
			return 0;
		}
		c = toupper (str_key[1]);
		if (! isalnum (c) && c != ' ')
		{
			Error ("Hotkey :  character '%c' is not alphanum or space", c);
			return 0;
		}
		virtual_key_code = c;
		return 1;
	}
// --- character ---

// +++ name +++
	str = str_key;
	mkupper(str);
#if 0
// todo :  make it normal, with names array
	if (str[0] == 'F')
	{
		strm << str;
// skip first symbol
		strm.rdbuf()->sbumpc();
		strm >> i;
		if (strm.fail() || ! strm.eof())
//			goto parse_as_number;
		{
			Error ("Hotkey :  name \"%s\" parse failed; possibly is not in support yet", str.c_str());
			return 0;
		}
		if (i < 1 || i >= 25)
		{
			Error ("Hotkey :  F key number %d is invalid; must be in 1-25 range", i);
			return 0;
		}
		virtual_key_code = VK_F1 - 1 + i;
		return 1;
	}
#else
	int keys_num;

	keys_num = NUMOF(g_strlist);
	for (i = 0; i < keys_num; i++)
	{
		strlist_t* strlist;
		int i_result;

		strlist = &g_strlist[i];
		i_result = str.compare(strlist->name);
		if (! i_result)
		{
			virtual_key_code = strlist->val;
			return 1;
		}
	}
#endif
// --- name ---

// +++ number +++
//parse_as_number:
	strm << str_key;
//	strm.rdbuf()->sbumpc();
//	strm.rdbuf()->sbumpc();
//	i = strm.flags ();
//	i |= ios::hex;
//	strm.flags (i);
// works just something one, if set both - 'ios::dec' and 'ios::hex'; must disable 'ios::dec' to allow both
// *flag defines are in <xiosbase>
	strm.unsetf (ios::dec);
//	strm.setf (ios::hex);
	strm >> i;
	if (strm.fail() || ! strm.eof())
	{
		Error ("Hotkey :  sign \"%s\" cannot be parsed nor as a character nor as a virtual key name nor as a number", str_key.c_str());
		return 0;
	}
// *0xff actually is reserved, so allow it
	if (i < 1 || i >= 0x100)
	{
		Error ("Hotkey :  number 0x%02x is invalid; must be in 0x01-0x100 range", i);
		return 0;
	}
	virtual_key_code = i;
// --- number ---

	return 1;
}

#if 0
//void Hotkey_Register (hotkey_info_t* hotkey_info)
void Hotkey_Add (byte key_code, string action, string arg)
{
	bool result;

	Assert(hot_keys);
	if (! hotkey_info.modifier)
		Error ("Hotkey modifier (hotkey_modifier variable in config file) is not defined.\nChoose something from Shift, Ctrl, Alt and Win keys combination.");

// == hotkey functions ==
	hotkey_info.bool_ptr = 0;
// restore screen
	hotkey_info.vkey_code = 'R';
	hotkey_info.function = Screen_Restore;
	result = hot_keys->Add (&hotkey_info);
	if (! result)
		Error ("adding hot key '%c' failed", hotkey_info.vkey_code);
#if RESEARCH
	hotkey_info.vkey_code = 'A';
	hotkey_info.function = MsgRecord_Start;
	hotkey_info.vkey_code = 'S';
	hotkey_info.function = MsgRecord_Stop;
#if 0
// one more test
	hotkey_info.vkey_code = 'Y';
	hotkey_info.function = Cursor_Show;
#endif
#endif
// == hotkey booleans ==
// quit
	hotkey_info.function = 0;
	hotkey_info.vkey_code = 'Q';
	hotkey_info.bool_ptr = &hotkey_exit;
	result = hot_keys->Add (&hotkey_info);
	if (! result)
		Error ("adding hot key '%c' failed", hotkey_info.vkey_code);
}
#endif

// +++ some commands +++

void Cmd (void* user_data)
{
//	const char* cmd;
	string* cmd;
//	int i_result;
	UINT UI_result;

	Assert(user_data);
//	cmd = (char*)user_data;
	cmd = (string*)user_data;
//	execl ();
//	spawnl ();
// completely blocks
//	i_result = system (cmd);
// does not shows at all
//	UI_result = WinExec (cmd, SW_HIDE);
// displays and activates
//	UI_result = WinExec (cmd, SW_SHOWDEFAULT);
// crap; displays over, but not active
//	UI_result = WinExec (cmd, SW_SHOWNA);
// crap; displays over, but not active
//	UI_result = WinExec (cmd, SW_SHOWNOACTIVATE);
	UI_result = WinExec (cmd->c_str(), SW_SHOWNORMAL);
}

void CmdMin (void* user_data)
{
//	const char* cmd;
	string* cmd;
//	int i_result;
	UINT UI_result;

	Assert(user_data);
//	cmd = (char*)user_data;
	cmd = (string*)user_data;
	UI_result = WinExec (cmd->c_str(), SW_SHOWMINNOACTIVE);
}

//void Cmd_ShowDesktop (void* user_data)
//{
//}

// here, or all should be 'ErrorReport ()', or all 'Notify_Warnf ()'; otherwise, the return result needs to be nonboolean, or need a two return results
// now :  return 0, if the string is invalid
bool Hotkey_Register_ChangeScreenResolution (string arg)
{
	bool result;
//	string* cmd;
	screen_resolution_t screen_resolution;
	stringstream strm;

	memset (&screen_resolution, 0, sizeof(screen_resolution));
	strm << arg;
// default values were not meant in the description about this
	strm >> screen_resolution.width >> screen_resolution.height >> screen_resolution.bpp;
	if (strm.fail())
	{
//		ErrorReport ("Hotkey_Register_ChangeScreenResolution () :  cannot parse width height and bpp from the string \"%s\"", arg.c_str());
		Notify_Warnf ("Hotkey_Register_ChangeScreenResolution () :  cannot parse width height and bpp from the string \"%s\"", arg.c_str());
		return 0;
	}
	ws(strm);
	if (! strm.eof())
	{
// 0 and 1 are for default
		strm >> screen_resolution.refresh;
		if (strm.fail())
		{
//			ErrorReport ("Hotkey_Register_ChangeScreenResolution () :  cannot parse refresh frequence from the string \"%s\"", arg.c_str());
			Notify_Warnf ("Hotkey_Register_ChangeScreenResolution () :  cannot parse refresh frequence from the string \"%s\"", arg.c_str());
			return 0;
		}
		ws(strm);
		if (! strm.eof())
		{
//			ErrorReport ("Hotkey_Register_ChangeScreenResolution () :  the string \"%s\" - need only 3 or 4 integer values", arg.c_str());
			Notify_Warnf ("Hotkey_Register_ChangeScreenResolution () :  the string \"%s\" - need only 3 or 4 integer values", arg.c_str());
			return 0;
		}
	}

	result = Screen_Mode_IsSupported (&screen_resolution);
	if (! result)
	{
// do not throw mbox on that; should be logged and exclamated instead
//		ErrorReport ("Hotkey_Register_ChangeScreenResolution () :  mode width=%d, height=%d, bpp=%d, refresh=%d is unsupported", screen_resolution.width, screen_resolution.height, screen_resolution.bpp, screen_resolution.refresh);
		Notify_Warnf ("Hotkey_Register_ChangeScreenResolution () :  mode width=%d, height=%d, bpp=%d, refresh=%d is unsupported", screen_resolution.width, screen_resolution.height, screen_resolution.bpp, screen_resolution.refresh);
		return 0;
//		return 1;
	}

	hotkey_info.function = Screen_Hotkey_ChangeScreenResolution;
	hotkey_info.user_data = new screen_resolution_t (screen_resolution);
	return 1;
}

// --- some commands ---

//void Hotkey_Add (char* key, char* action, char* arg)
//{
//}
// return 0 when if failed to do some, and the program is disallowed to continue
#if 0
//bool Hotkey_Parse (string2 str_key, string2 str_action, string str_arg)
//bool Hotkey_Parse (char* str_key, char* str_action, char* str_arg)
bool Hotkey_Parse (string key, string action, string arg)
{
	bool result;
	int virtual_key_code;
//	string key;
//	string action;
//	string arg;

	Assert(hot_keys);
	if (! hotkey_info.modifier)
		Error ("Hotkey modifier (hotkey_modifier variable in config file) is not defined.\nChoose something from Shift, Ctrl, Alt and Win keys combination.");

// info, for the case if registration will be denied
	strncpy (hotkey_info.key_name, key.c_str(), sizeof(hotkey_info.key_name) - 1);
	hotkey_info.key_name[sizeof(hotkey_info.key_name) - 1] = 0;

//	key = str_key;
//	action = str_action;
//	arg = str_arg;
	result = Hotkey_ParseKey (*key, virtual_key_code);
	if (! result)
	{
		return 0;
	}

	hotkey_info.vkey_code = virtual_key_code;
// + cleanup +
	hotkey_info.function = 0;
	hotkey_info.user_data = 0;
	hotkey_info.bool_ptr = 0;
// - cleanup -
	mklower(action);
	if (! action.compare("quit"))
	{
		hotkey_info.bool_ptr = &hotkey_exit;
		goto command_without_arg;
	}
	if (! action.compare("restdisp"))
	{
		hotkey_info.function = Screen_Restore;
		goto command_without_arg;
	}
	if (! action.compare("cmd"))
	{
		hotkey_info.function = Cmd;
		hotkey_info.user_data = new string (arg);
		goto command_with_arg_string;
	}
// start program, but ask that its window would be minimized
	if (! action.compare("cmdmin"))
	{
		hotkey_info.function = CmdMin;
		hotkey_info.user_data = new string (arg);
		goto command_with_arg_string;
	}
// hehe, already exist on Win+D, Win+M (minimize all)
//	if (! action.compare("show_desktop"))
//	{
//		hotkey_info.function = Cmd_ShowDesktop;
//		goto command_without_arg;
//	}
// + sound volume +
	if (! action.compare("volup"))
	{
		hotkey_info.function = Volume_Up;
		goto command_without_arg;
	}
	if (! action.compare("voldown"))
	{
		hotkey_info.function = Volume_Down;
		goto command_without_arg;
	}
// - sound volume -
	if (! action.compare("change_screen_resolution"))
	{
//		hotkey_info.function = Hotkey_ChangeScreenResolution;
//		hotkey_info.user_data = new string (arg);
		result = Hotkey_Register_ChangeScreenResolution (arg);
		if (! result)
			return 0;
		goto command_with_arg_string;
	}

	Error ("Hotkey \"%s\" :  unknown action \"%s\"", key.c_str(), action.c_str());
	return 0;

command_without_arg:
	if (! arg.empty())
	{
		Error ("Hotkey \"%s\" :  command \"%s\" does not require any argument", key.c_str(), action.c_str());
		return 0;
	}
	goto register_command;
command_with_arg_string:
	if (arg.empty())
	{
		Error ("Hotkey \"%s\" :  command \"%s\" requires string argument", key.c_str(), action.c_str());
		return 0;
	}
	goto register_command;
register_command:
//	result = hot_keys->Add (&hotkey_info);
	result = hot_keys->Add (&hotkey_info, 0, 0);
	if (! result)
		Error ("adding hot key '%c' failed", hotkey_info.vkey_code);
	return 1;
}
#else
bool Hotkey_Parse (vec_str_t& vec_str_args)
{
	bool result;
	int virtual_key_code;
//	string key;
//	string action;
//	string arg;
	string key;
	string action;
	string* arg0;
	uint args_num;
	uint required_args_num;

	Assert(hot_keys);
	if (! hotkey_info.modifier)
		Error ("Hotkey modifier (hotkey_modifier variable in config file) is not defined.\nChoose something from Shift, Ctrl, Alt and Win keys combination.");

	args_num = vec_str_args.size();
	Assert(args_num >= 1);
	key = vec_str_args[0];
	if (args_num < 2)
	{
		Error ("Hotkey \"%s\" :  no command", key.c_str());
		return 0;
	}
	action = vec_str_args[1];

// info, for the case if registration will be denied
	strncpy (hotkey_info.key_name, key.c_str(), sizeof(hotkey_info.key_name) - 1);
	hotkey_info.key_name[sizeof(hotkey_info.key_name) - 1] = 0;

	result = Hotkey_ParseKey (key, virtual_key_code);
	if (! result)
	{
		return 0;
	}

	hotkey_info.vkey_code = virtual_key_code;
// + cleanup +
	hotkey_info.function = 0;
	hotkey_info.user_data = 0;
	hotkey_info.bool_ptr = 0;
// - cleanup -
	mklower(action);

	if (! action.compare("quit"))
	{
		CONFIG_CHECK_ARGS_NUM(2);
		hotkey_info.bool_ptr = &hotkey_exit;
//		goto command_without_arg;
		goto register_command;
	}
	if (! action.compare("restdisp"))
	{
		CONFIG_CHECK_ARGS_NUM(2);
		hotkey_info.function = Screen_Restore;
//		goto command_without_arg;
		goto register_command;
	}
	if (! action.compare("cmd"))
	{
		CONFIG_CHECK_ARGS_NUM(3);
		arg0 = &vec_str_args[2];
		hotkey_info.function = Cmd;
		hotkey_info.user_data = new string (*arg0);
//		goto command_with_arg_string;
		goto register_command;
	}
// start program, but ask that its window would be minimized
	if (! action.compare("cmdmin"))
	{
		CONFIG_CHECK_ARGS_NUM(3);
		arg0 = &vec_str_args[2];
		hotkey_info.function = CmdMin;
		hotkey_info.user_data = new string (*arg0);
//		goto command_with_arg_string;
		goto register_command;
	}
// hehe, already exist on Win+D, Win+M (minimize all)
//	if (! action.compare("show_desktop"))
//	{
//		hotkey_info.function = Cmd_ShowDesktop;
//		goto command_without_arg;
//	}
// + sound volume +
	if (! action.compare("volup"))
	{
		CONFIG_CHECK_ARGS_NUM(2);
		hotkey_info.function = Volume_Up;
//		goto command_without_arg;
		goto register_command;
	}
	if (! action.compare("voldown"))
	{
		CONFIG_CHECK_ARGS_NUM(2);
		hotkey_info.function = Volume_Down;
//		goto command_without_arg;
		goto register_command;
	}
// - sound volume -
	if (! action.compare("change_screen_resolution"))
	{
// if allow to omit refresh rate
//		CONFIG_CHECK_ARGS_NUM_MIN(5);
//		CONFIG_CHECK_ARGS_NUM(6);
// if by a single arg string
		CONFIG_CHECK_ARGS_NUM(3);
		arg0 = &vec_str_args[2];
//		hotkey_info.function = Hotkey_ChangeScreenResolution;
//		hotkey_info.user_data = new string (arg);
		result = Hotkey_Register_ChangeScreenResolution (*arg0);
		if (! result)
// a user is warned in the console, don't return as a fail
//			return 0;
			return 1;
//		goto command_with_arg_string;
		goto register_command;
	}
	if (! action.compare("show_console"))
	{
		CONFIG_CHECK_ARGS_NUM(2);
		hotkey_info.function = WndConsole_Activate;
		goto register_command;
	}

	Error ("Hotkey \"%s\" :  unknown action \"%s\"", key.c_str(), action.c_str());
	return 0;

#if 0
command_without_arg:
//	if (! arg.empty())
	if (args_num != 2)
	{
		Error ("Hotkey \"%s\" :  command \"%s\" does not require any argument", key.c_str(), action.c_str());
		return 0;
	}
	goto register_command;
#endif
#if 0
//command_with_arg_string:
command_with_args_1:
//	if (arg.empty())
	if (args_num != 3)
	{
		Error ("Hotkey \"%s\" :  command \"%s\" requires string argument", key.c_str(), action.c_str());
		return 0;
	}
	goto register_command;
#endif
register_command:
	result = hot_keys->Add (&hotkey_info, 0, 0);
	if (! result)
		Error ("adding hot key '%c' failed", hotkey_info.vkey_code);
	return 1;

wrong_args_num:
	Error ("Config :  line %u, command requires %u arguments, got %u", config_string_num, required_args_num, args_num);
	return 0;
}
#endif

#if 0
void Hotkeys_Register ()
{
	bool result;
	result = hot_keys->ActivateAll ();
}
#endif

