#pragma once

// by Alexander Ilyin

//#include <windows.h>
//#include "hot_keys.h"
#include "types.h"
#include "video.h"
#include "main.h"


extern bool screen_error;
// +++ config +++
extern bool screen_force_32bit;
extern bool screen_double_switch_hack;
// --- config ---


bool Screen_Mode_IsSupported (uint width, uint height, uint bpp, uint refresh);
bool Screen_Mode_IsSupported (screen_resolution_t* screen_resolution);
bool Screen_ModeRefresh_Find (int* ix, int width, int height, int bpp, int* refresh);
void Screen_ModeRefresh_Add (int width, int height, int bpp, int refresh);
bool Screen_WholeStruct_GetSize (uint* size, bool refreshlock);
void Screen_WholeStruct_Pack (void* buffer, bool refreshlock);

bool Screen_ParseString_ModesConfig (const char* cfg_str);
//Config_ParsingSubr_Plain_t Screen_ParseString_ModesConfig;
//void Screen_Restore ();
//HotKeyFunction_t Screen_Restore;
void Screen_Restore (void*);
#if USE_WNDPROC_MESSAGES
bool Screen_OnDisplayChange (int width, int height, int bpp, bool* is_screen_changed);
void Screen_OnTimer ();
#endif
// +++ hotkeys +++
void Screen_Hotkey_ChangeScreenResolution (void* user_data);
// --- hotkeys ---

