// read C string or Constant Literal
// perhaps should belong at C Reformatter project, but atm it isn't

#include "c_string.h"
#include "error.h"


//const char* cstring_error_text = "- uninitialized -";
// hmmm, what the sense
//static char error_buffer[256];
char cstring_error_text[256];


// C string escape sequences :
// \' \" \? \\
// \a 07 \b 08 \f 0c \n 0a \r 0d \t 09 \v 0b
// \ octal-number (one, two or three)
// \x hexadecimal-number
// universal-character :  \u or \U hex-quad
// for hexadecimal and octal it reads characters until those characters are valid for it

// *should also actually take mode :  single byte, Unicode, multibyte character
//bool CString_Escape (std::string& str_out, const char*& str_in)
//bool CString_Escape (std::string& str_out, string::iterator it_str_in, string::iterator it_str_in_end)
bool CString_Escape (std::string& str_out, string::iterator& it_str_in, string::iterator it_str_in_end)
{
//	char* test_string = "\a \b \f \n \r \t \v";
//	char* test_string = __func__;
//	char* test_string = "\x000129";
	char c;
	char c1;

//	c = *str_in;
	if (it_str_in == it_str_in_end)
		goto string_end;
	c = *it_str_in;
	switch (c)
	{
// single quote
	case '\'':
// let it be used
		break;
// double quote
	case '\"':
// let it be used
		break;
// question mark
	case '?':
// let it be used
		break;
// back slash
	case '\\':
// let it be used
		break;
// alert
	case 'a':
		c = 0x07;
		break;
// backspace
	case 'b':
		c = 0x08;
		break;
// form feed
	case 'f':
		c = 0x0c;
		break;
// new line
	case 'n':
		c = 0x0a;
		break;
// carriage return
	case 'r':
		c = 0x0d;
		break;
// horizontal tab
	case 't':
		c = 0x09;
		break;
// vertical tab
	case 'v':
		c = 0x0b;
		break;
// octal (digits)
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
// '\8' and '\9' are not in use
//	case '8':
//	case '9':
loop_octal:
//		str_in++;
		it_str_in++;
		if (it_str_in == it_str_in_end)
			goto string_end;
//		c1 = *str_in;
		c1 = *it_str_in;
		if (c1 >= '0' && c1 < '8')
		{
			c1 -= '0';
			c <<= 3;
			c |= c1;
			goto loop_octal;
		}
		break;
// hexadecimal
// '\X' is not in use
	case 'x':
loop_hexadecimal:
//		str_in++;
		it_str_in++;
		if (it_str_in == it_str_in_end)
			goto string_end;
//		c1 = *str_in;
		c1 = *it_str_in;
		if (c1 >= '0' && c1 <= '9')
		{
			c1 -= '0';
			goto hexadecimal_digit;
		}
		if (c1 >= 'A' && c1 <= 'Z')
		{
			c1 -= 'A' - 10;
			goto hexadecimal_digit;
		}
		if (c1 >= 'a' && c1 <= 'z')
		{
			c1 -= 'a' - 10;
			goto hexadecimal_digit;
		}
		break;
hexadecimal_digit:
		c <<= 4;
		c |= c1;
		goto loop_hexadecimal;
// universal-character
	case 'u':
	case 'U':
//		c = 0x0;
//		cstring_error_text = "unicode is not in support atm";
		sprintf (cstring_error_text, "unicode is not in support atm");
		return 0;
		break;
	default:
//		sprintf (error_buffer, "unknown escape character %02x after '\\'", c);
//		cstring_error_text = error_buffer;
		sprintf (cstring_error_text, "unknown escape character %02x after '\\'", c);
		return 0;
	}
	it_str_in++;
	str_out += c;

	return 1;

string_end:
//	cstring_error_text = "string end in escape sequence";
	sprintf (cstring_error_text, "string end in escape sequence");
	return 0;
}

//bool CString_Read (std::string& str_out, const char*& str_in)
bool CString_Read (std::string& str_out, string::iterator& it_str_in, string::iterator it_str_in_end)
{
	bool result;
	char c;
	int type = 0;

//	cstring_error_text = "- no error -";
	sprintf (cstring_error_text, "- no error -");
// perhaps no, to allow append
//	str_out.erase();
// although this character already is tested, but it is better to redefine the type of value here,
// this will let to output 'str_in' pointing after the closing quote, and summary will look good :  start from on a quote - end after quotes end
	if (it_str_in == it_str_in_end)
		goto string_end;
//	c = *str_in;
	c = *it_str_in;
	switch (c)
	{
// single quote
	case '\'':
		type = 1;
		break;
// double quote
	case '\"':
		type = 2;
		break;
	default:
//		sprintf (error_buffer, "it is not a C string, the first symbol is %02x", c);
//		cstring_error_text = error_buffer;
		sprintf (cstring_error_text, "it is not a C string, the first symbol is %02x", c);
		return 0;
	}
//	str_in++;
	it_str_in++;

	Assert(type);
loop_characters:
	if (it_str_in == it_str_in_end)
		goto string_end;
//	c = *str_in;
	c = *it_str_in;
//	str_in++;
	it_str_in++;
#if 0
	if (! c)
	{
//		cstring_error_text = "string ended without a closing quote";
		sprintf (cstring_error_text, "string ended without a closing quote");
		return 0;
	}
#endif
	switch (c)
	{
// single quote
	case '\'':
		if (type == 1)
			goto finish;
		break;
// double quote
	case '\"':
		if (type == 2)
			goto finish;
		break;
// backslash escape
	case '\\':
//		result = CString_Escape (str_out, str_in);
		result = CString_Escape (str_out, it_str_in, it_str_in_end);
		if (! result)
// an error already is printed
			return 0;
//		break;
		goto loop_characters;
	}
	str_out += c;
	goto loop_characters;

finish:
//	str_in++;
//	it_str_in++;
	return 1;

// given string's end, not the C string's one
string_end:
	sprintf (cstring_error_text, "string ended without a closing quote");
	return 0;
}

