#pragma once

#include "types.h"


#define GRAPH_LINES_NUM_MAX 5

// value for a line
struct measure_value_t
{
// not in use atm; intended to show value kind :  linear, bended in some way ...
	uint type;
	uint value;
	struct
	{
		uint min;
		uint max;
	};
};

extern measure_value_t measure_values[GRAPH_LINES_NUM_MAX];

enum
{
	MEASURE_LINE_TYPE__NONE,
	MEASURE_LINE_TYPE__SYSTEM_POWER_STATUS,
	MEASURE_LINE_TYPE__SYSTEM_TIMES,
	MEASURE_LINE_TYPE__GLOBAL_MEMORY_STATUS,
	MEASURE_LINE_TYPE__WMI,
	MEASURE_LINE_TYPE_NUM
};

// line value description - how to get it
struct measure_line_t
{
	uint type;
//	uint val_ix;
};

extern measure_line_t measure_lines[GRAPH_LINES_NUM_MAX];
extern char measure_tooltip[];


void Measure_Init ();
void Measure_Quit ();
void Measure_GetValues ();
void Measure_OutputValues ();

