#pragma once

#include "video.h"
#include "config.h"


#define DLL_PORT_FILE_MAPPING_NAME "Global\\Win_Resident_Tools_dll_port"

// any values; just id; mostly to ensure, that the sizes are proper
#define DLL_PORT_ID_0 0x6FC668E3
#define DLL_PORT_ID_1 0x5B6DE86F
#define DLL_PORT_ID_2 0x0A6126FC
#define DLL_PORT_ID_3 0xE5DC9BFA
#define DLL_PORT_ID_4 0x637070D5
#define DLL_PORT_ID_5 0x5A7B6FD3
#define DLL_PORT_ID_6 0x3010FF1B
#define DLL_PORT_ID_7 0x24BE8301

#if 0
typedef struct
{
	int width;
	int height;
	int bpp;
	int refresh;
} forced_resolution_refreshrate_t;
#endif
typedef screen_resolution_t forced_resolution_refreshrate_t;

//enum
//{
//	;
//};

// increase this, to show incompatibility
#define PORT_VERSION 2

//#define PORT_FLAG_REFRESHLOCK 0X00000001

typedef struct
{
// which features are necessary
//	ulong flags;
	bool refreshlock;
	ulong refreshlock_delay;
} config_settings_t;

typedef struct
{
	ulong id0;
	ulong id1;
	ulong version;
	config_settings_t config_settings;
	ulong video_mode_struct_size;
	ulong video_modes_num;
	ulong id2;
	ulong id3;
} port_begin_t;

typedef struct
{
	ulong id4;
	ulong id5;
	ulong id6;
	ulong id7;
} port_end_t;

