// have a nice day :)

#include "volume.h"
#include <windows.h>
#include "wnd_volume.h"
// what has disabled signed<>unsigned warning ?


uint volume_device = 0;
uint volume_step = 1024;


//void Volume_Change (bool up)
void Volume_Manage (bool up, bool change)
{
	MMRESULT mmresult;
//	HMIXER hmixer;
	HMIXEROBJ hmixerobj;
	uint i;
	MIXERLINE line;
	MIXERLINECONTROLS controls;
	MIXERCONTROL control;
	MIXERCONTROLDETAILS details;
	MIXERCONTROLDETAILS_UNSIGNED value;
	DWORD control_id;
	ulong val;

// check device ix
	i = mixerGetNumDevs ();
// **check it
	if (! i)
		return;
	if (volume_device >= i)
		return;

// open
//	mmresult = mixerOpen (&hmixer, volume_device ,0 ,0 ,MIXER_OBJECTF_MIXER);
//	mmresult = mixerOpen ((HMIXER*)&hmixerobj, volume_device ,0 ,0 ,MIXER_OBJECTF_MIXER);
// not a problem when a program touches this; except if it uses this for own volume control, then completely wrong
	mmresult = mixerOpen ((HMIXER*)&hmixerobj, volume_device ,0 ,0 ,MIXER_OBJECTF_HMIXER);
// when a program controls this, it is very wrong; only manual setting on mixer must modify this
//	mmresult = mixerOpen ((HMIXER*)&hmixerobj, volume_device ,0 ,0 ,MIXER_OBJECTF_HWAVEOUT);
	if (mmresult != MMSYSERR_NOERROR)
	{
		return;
	}

// get line id
	line.cbStruct = sizeof(line);
	line.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS;
	mmresult = mixerGetLineInfo (hmixerobj, &line, MIXER_GETLINEINFOF_COMPONENTTYPE);
	if (mmresult != MMSYSERR_NOERROR)
	{
		goto close_mixer;
	}
// get control id
// **
	control_id = 0;
	control.cbStruct = sizeof(MIXERCONTROL);
	controls.cbStruct = sizeof(MIXERLINECONTROLS);
	controls.dwLineID = line.dwLineID;
	controls.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME;
	controls.cbmxctrl = sizeof(MIXERCONTROL);
	controls.pamxctrl = &control;
	mmresult = mixerGetLineControls(hmixerobj, &controls, MIXER_GETLINECONTROLSF_ONEBYTYPE);
	if (mmresult != MMSYSERR_NOERROR)
	{
		goto close_mixer;
	}
	control_id = control.dwControlID;

// get volume
	memset (&value, 0, sizeof(MIXERCONTROLDETAILS_UNSIGNED));
	memset (&details, 0, sizeof(details));
	details.cbStruct = sizeof(details);
//	details.cbStruct = sizeof(MIXERCONTROLDETAILS);
	details.dwControlID = control_id;
// all channels
	details.cChannels = 1;
//	details.cMultipleItems = 0;
	details.cbDetails = sizeof(MIXERCONTROLDETAILS_UNSIGNED);
	details.paDetails = &value;

//	mmresult = mixerGetControlDetails ((HMIXEROBJ)hmixer, &details, MIXER_GETCONTROLDETAILSF_VALUE);
	mmresult = mixerGetControlDetails (hmixerobj, &details, MIXER_GETCONTROLDETAILSF_VALUE);
	if (mmresult != MMSYSERR_NOERROR)
	{
		goto close_mixer;
	}

	if (! change)
		goto close_mixer;

// modify volume
	if (volume_step > (ushort)-1)
		volume_step = (ushort)-1;
	val = value.dwValue;
	if (up)
	{
		val += volume_step;
		if (val > (ushort)-1)
			val = (ushort)-1;
	}
	else
	{
		val -= volume_step;
		if ((signed)val < 0)
			val = 0;
	}
	value.dwValue = val;
// set volume
//	mmresult = mixerSetControlDetails ((HMIXEROBJ)hmixer, &details, MIXER_GETCONTROLDETAILSF_VALUE);
	mmresult = mixerSetControlDetails (hmixerobj, &details, MIXER_GETCONTROLDETAILSF_VALUE);
	if (mmresult != MMSYSERR_NOERROR)
	{
	}

close_mixer:
//	mmresult = mixerClose (hmixer);
	mmresult = mixerClose ((HMIXER)hmixerobj);
	if (mmresult != MMSYSERR_NOERROR)
	{
	}

	WndVolume_SetValue (value.dwValue);
	WndVolume_Display ();
}

void Volume_Up (void* user_data)
{
//	Volume_Change (1);
	Volume_Manage (1, 1);
}

void Volume_Down (void* user_data)
{
//	Volume_Change (0);
	Volume_Manage (0, 1);
}

